;TIP1061B.LSP:  DDIMTOLR.LSP   Add Tolerances to Dimensions   (c)1995, Jim Hollingsworth 

;;  Routine to add tolerences to an "unexploded" dimension, also
;;  the user can force the text inside the extension lines.   

;; Lines that begin ";;sld" are required for using slides.
;; Requires DDIMTOLR.DCL

;; Error handler
(defun tolr_err (MSG)
   (setq *error* OLDERR)
   (if (not TOLRERR)
      (princ (strcat "\nDDimtolr error: " MSG))
      (princ TOLRERR)
   );if
   (if OLDTOL (setvar "DIMTOL" OLDTOL))
   (if OLDLIM (setvar "DIMLIM" OLDLIM))
   (if OLDTIX (setvar "DIMTIX" OLDTIX))
   (if OLDHIGH (setvar "HIGHLIGHT" OLDHIGH))
   (if OLDCMDE (setvar "CMDECHO" OLDCMDE))
   (princ)
);defun
;;
;; --------------------------------------------------------------------------
;; Prompts the user to pick a dimension
;;
(defun tolruser ()
   (setq I 1)
   (while (= I 1)
      (setq ENTPICK (car (entsel "\nSelect a DIMENSION: ")))
      (while (= ENTPICK nil)
         (prompt "Nothing picked, try again! ")
         (setq ENTPICK (car (entsel "\nSelect a DIMENSION: ")))
      );while
      (setq ETTYPE (cdr (assoc 0 (entget entpick))))
      (if (= ETTYPE "DIMENSION")
         (setq I 2)
         (prompt "Selection was not a DIMENSION! ")
      );if
   );while
   (princ)
);defun tolruser
;;
;; --------------------------------------------------------------------------
;; Setting up variables that are used in the LISP
;;
(defun tolrset ()
   (if (= OLDTP nil)
      (setq OLDTP 0)
   );if
   (if (= Oldtm nil)
      (setq OLDTM 0)
   );if
   (setq NEWTM OLDTM)
   (setq NEWTP OLDTP)
   (if (and (/= OLDTOL 1) (/= OLDLIM 1))
      (progn
         (setq OLDNONE 1)
         (setq TTOLR 1)
      );progn
      (setq OLDNONE nil)
   );if
   (if (= OLDTOL 1)
      (setq TTOLR 2)
   );if
   (if (= OLDLIM 1)
      (setq TTOLR 3)
   );if
   (if (= OLDTIX 1)
      (progn
         (setq OLDTIXYES 1)
         (setq OLDTIXNO nil)
         (setq TTIX 1)
      );progn
      (progn
         (setq OLDTIXYES nil)
         (setq OLDTIXNO 1)
         (setq TTIX 2)
      );progn
   );if
   (princ)
);defun tolrset
;;
;; --------------------------------------------------------------------------
;; Loads dialog DDIMTOLR.DCL
;;
(defun tolr_dialog ()
   (setq DCLYES nil)
   (setq DCL_ID (load_dialog "DDIMTOLR.DCL"))
   (if (not (new_dialog "dim_tolr" DCL_ID)) (exit))
   (if (= OLDNONE 1)
      (progn
         (set_tile "tolr_none" "1")
         (mode_tile "tolr_tp" 1)
         (mode_tile "tolr_tm" 1)
         ;;sld      (setq TOLRSLD "ddimtolr(ddimnone)")
      );progn
   );if
   (if (= OLDTOL 1)
      (progn
         (set_tile "tolr_tol" "1")
         ;;sld      (setq tolrsld "ddimtolr(ddimtol)")
      );progn
   );if
   (if (= OLDLIM 1)
      (progn
         (set_tile "tolr_lim" "1")
         ;;sld      (setq TOLRSLD "ddimtolr(ddimlim)")
      );progn
   );if
   ;;sld  (image_loader)
   (set_tile "tolr_tp" (strcat (rtos OLDTP)))
   (set_tile "tolr_tm" (strcat (rtos OLDTM)))
   (if (= OLDTIXYES 1)
      (set_tile "tix_yes" "1")
   );if
   (if (= OLDTIXNO 1)
      (set_tile "tix_no" "1")
   );if
   (action_tile "tolr_none" 
      (strcat
         "(progn (mode_tile \"tolr_tp\" 1)"
         "(mode_tile \"tolr_tm\" 1)"
         ;;sld      "(setq TOLRSLD \"ddimtolr(ddimnone)\")"
         ;;sld      "(image_loader)"
         "(setq TTOLR 1))"
      );strcat
   );action_tile 
   (action_tile "tolr_tol" 
      (strcat
         "(progn (mode_tile \"tolr_tp\" 0)"
         "(mode_tile \"tolr_tm\" 0)"
         ;;sld      "(setq tolrsld \"ddimtolr(ddimtol)\")"
         ;;sld      "(image_loader)"
         "(setq TTOLR 2))"
      );strcat
   );action_tile
   (action_tile "tolr_lim"
      (strcat
         "(progn (mode_tile \"tolr_tp\" 0)"
         "(mode_tile \"tolr_tm\" 0)"
         ;;sld      "(setq tolrsld \"ddimtolr(ddimlim)\")"
         ;;sld      "(image_loader)"
         "(setq TTOLR 3))"
      );strcat
   );action_tile
   (action_tile "tix_yes" "(setq TTIX 1)" )
   (action_tile "tix_no" "(setq TTIX 2)" )
   (action_tile "accept" 
      (strcat
         "(progn (setq NEWTP (atof (get_tile \"tolr_tp\")))"
         "(setq NEWTM (atof (get_tile \"tolr_tm\")))"
         "(done_dialog 1))"
      );strcat
   );action_tile
   (if (equal (start_dialog) 1)
      (setq DCLYES 1)
   );if
   (unload_dialog dcl_id)
   (princ)
);defun tolr_dialog
;;
;; --------------------------------------------------------------------------
;; Slide image loader
;;
(defun image_loader()
   (setq X (dimx_tile "tolr_image")
      Y (dimy_tile "tolr_image")
   )
   (start_image "tolr_image")
   (fill_image 0 0 X Y -2)
   (slide_image 0 0 X Y TOLRSLD)
   (end_image)
);defun image_loader
;;
;; --------------------------------------------------------------------------
;; The working body of the LISP
;;
(defun tolrwork ()
   (if (= TTOLR 1)
      (progn
         (setvar "DIMTOL" 0)
         (setvar "DIMLIM" 0)
      );progn
   );if
   (if (= TTOLR 2)
      (progn
         (setvar "DIMTOL" 1)
         (setvar "DIMLIM" 0)
      );progn
   );if
   (if (= TTOLR 3)
      (progn
         (setvar "DIMTOL" 0)
         (setvar "DIMLIM" 1)
      );progn
   );if
   (setvar "DIMTP" NEWTP)
   (setvar "DIMTM" NEWTM)
   (if (= TTIX 1)
      (setvar "DIMTIX" 1)
      (setvar "DIMTIX" 0)
   );if
   (command "DIM1" "UPDATE" ENTPICK "")
);defun tolrwork
;;
;; --------------------------------------------------------------------------
;; The mainbody of the LISP
;;
(prompt "Loading.......")
(defun C:DDIMTOLR ()
   (setq OLDERR *error*
      *error* TOLR_ERR
      OLDTOL nil
      OLDLIM nil
      OLDTIX nil
      OLDHIGH nil
      OLDCMDE nil
      TOLRERR nil
   );setq
   (tolruser)
   (setq OLDHIGH (getvar "HIGHLIGHT")
      OLDCMDE (getvar "CMDECHO")
      OLDTP (getvar "dimtp")
      OLDTM (getvar "dimtm")
      OLDLIM (getvar "dimlim")
      OLDTOL (getvar "dimtol")
      OLDTIX (getvar "dimtix")
   );setq
   (tolrset)
   (tolr_dialog)
   (if (= DCLYES 1)
      (progn
         (setvar "HIGHLIGHT" 0)
         (setvar "CMDECHO" 0)
         (tolrwork)
      );progn
   );if
   (setvar "HIGHLIGHT" OLDHIGH)
   (setvar "CMDECHO" OLDCMDE)
   (setvar "DIMTOL" OLDTOL)
   (setvar "DIMLIM" OLDLIM)
   (setvar "DIMTIX" OLDTIX)
   (setq *error* OLDERR)
   (princ)
);defun C:DDIMTOLR
(prompt "Done!")
(prompt "\nType DDIMTOLR to run.")
(princ); end ddimtolr.lsp
