;TIP1067.LSP:   TERMLINE.LSP   Trim or Extend Lines   (c)1995, Tom Arter

; termline.lsp implements a command that will either trim or extend the
; selected line(s) depending on what is needed. 
; It works by calculating where the lines should intersect
; and then changing the end point of the problem line to the 
; intersection point.

(defun C:TERMLINE (/ TOLINE TOLINEELIST SELSETLEN SELSET COUNT TOLINEENDPT1
   TOLINEENDPT2 LINEENDPT1 LINEENDPT2 OLDORTHO OLDOSMODE)

   (command "undo" "mark")
   (setq OLDORTHO (getvar "ORTHOMODE")
      OLDOSMODE (getvar "OSMODE")
   )
   (setvar "ORTHOMODE" 0)
   (setvar "OSMODE" 0)
   (princ "\n Osnap & Ortho have been turned off")

   (setq TOLINE (entsel "\n Pick line to extend or trim to: "))
   (setq TOLINEELIST (entget (car TOLINE)))
   (redraw (car TOLINE) 3)

   (setq TOLINEENDPT1 (cdr (assoc 10 TOLINEELIST))
      TOLINEENDPT2 (cdr (assoc 11 TOLINEELIST))
   )
   (if (= "LINE" (cdr (assoc 0 TOLINEELIST)))
      (progn
         (princ "\n Select lines to be extended or trimmed: ")
         (setq SELSET (ssget)   ; note no error trapping if no selection set
            SELSETLEN (sslength SELSET)
            COUNT 0
         )

         (while (< COUNT SELSETLEN)
            (setq ENAME (ssname SELSET COUNT))
            (setq ELIST (entget ENAME))
            (if (= "LINE" (cdr (assoc 0 ELIST)))
               (progn
                  (setq LINEENDPT1 (cdr (assoc 10 ELIST))
                     LINEENDPT2 (cdr (assoc 11 ELIST))
                  )
                  (setq INTPT (inters TOLINEENDPT1 TOLINEENDPT2 LINEENDPT1 LINEENDPT2 nil))
                  (command "change" ENAME "" INTPT)
               )
               (princ "\n Object is not a line")
            )
            (setq COUNT (+ COUNT 1))
         )
      ) ; end 1st progn
      (princ "\n Object was not a line, TermLine aborted")
   )

   (redraw (car TOLINE) 4)   
   (setvar "ORTHOMODE" OLDORTHO)
   (setvar "OSMODE" OLDOSMODE)
   (princ "\n Osnap & Ortho have been restored ")
   (princ)
); end termline.lsp
