;TIP1069.LSP:  BLKSCL.LSP   Scale Blocks Dynamically   (c)1995, John Helton

(Defun info_block ( /)
   (Princ "\nKeys:  ^S  |  ^RIGHT  |  ^LEFT  |  ^UP  |  ^DOWN  | ^PGUP |  ^PGDN  |  ENTER  ")
   (princ "\n           |          |         |       |         |       |         |         ")
   (princ "\nTask: Step |    X+1   |   X+1   |  Y+1  |   Y-1   |  Z+1  |   Z-1   |   Exit  ")
)

(defun get_step ( / NEW_STEP)
   (setq NEW_STEP (getreal (strcat "\nEnter Increment Value for scaling <"
   (rtos STEP 2 2) ">: ")))

   (if (= NEW_STEP nil)(setq NEW_STEP STEP)(setq STEP NEW_STEP))
   (info_block)
)

(defun C:BLKSCL ( /
      LOOP ;  -  main loop
      BLOCK ;  -  selected block
      ENTITY ;  -  assocation list of select block
      OLD-XGC ;  -  old assocation list with x scale factor
      OLD-YGC ;  -  old assocation list with y scale factor
      OLD-ZGC ;  -  old assocation list with z scale factor
      OLDX ;  -  current x scale factor
      OLDY ;  -  current y scale factor
      OLDZ ;  -  current z scale factor
      INPUT ;  -  ascii value of key pressed
      NEW-XGC ;  -  new assocation list with new x scale factor
      NEW-YGC ;  -  new assocation list with new y scale factor
      NEW-ZGC ;  -  new assocation list with new z scale factor
      NEW-BLK ;  -  new assocation list with modify scale factors
   )

   (setvar "cmdecho" 0)
   (setq   LOOP nil)
   (setq ENTITY nil)
   (if (null STEP) (setq STEP 1))
   (While (null ENTITY)
      (setq ENTITY (car (entsel "\nPick Block to Stretch: ")))
   )

   (setq   BLOCK (entget ENTITY))
   (info_block)

   (while (/= LOOP 13)
      (setq
         OLD-XGC (assoc 41 BLOCK)
         OLD-YGC (assoc 42 BLOCK)
         OLD-ZGC (assoc 43 BLOCK)
         OLDX (cdr OLD-XGC)
         OLDY (cdr OLD-YGC)
         OLDZ (cdr OLD-ZGC)
      );setq

      (grtext -2 (strcat "(C) 1992 John Helton"))
      (grtext -1 (strcat "Scale: X:"   (RTOS OLDX 2 2) "  Y:"
            (RTOS OLDY 2 2) "  Z:"
      (RTOS OLDZ 2 2)))

      (SETQ INPUT (grread))
      (setq LOOP (cadr INPUT))
      (IF (= LOOP 19)(GET_STEP))
      (if (= LOOP 141)(SETQ OLDY (+ OLDY STEP)))
      (if (= LOOP 145)(SETQ OLDY (- OLDY STEP)))
      (if (= LOOP 244)(SETQ OLDX (+ OLDX STEP)))
      (if (= LOOP 243)(SETQ OLDX (- OLDX STEP)))
      (if (= LOOP 132)(SETQ OLDZ (+ OLDZ STEP)))
      (if (= LOOP 246)(SETQ OLDZ (- OLDZ STEP)))

      (setq NEW-XGC (cons 41 OLDX)
         NEW-YGC (cons 42 OLDY)
         NEW-ZGC (cons 43 OLDZ)
      )

      (if (or (= LOOP 244) (= LOOP 243))
         (setq NEW-BLK (subst NEW-XGC OLD-XGC BLOCK))
      )

      (if (or (= LOOP 141) (= LOOP 145))
         (setq NEW-BLK (subst NEW-YGC OLD-YGC BLOCK))
      )

      (if (or (= LOOP 132) (= LOOP 246))
         (setq NEW-BLK (subst NEW-ZGC OLD-ZGC BLOCK))
      )

      (if (or (= LOOP 244) (= LOOP 243)
            (= LOOP 141) (= LOOP 145)
            (= LOOP 132) (= LOOP 246)
         )
         (entmod NEW-BLK)
      )

      (if (/= LOOP 19)(setq BLOCK NEW-BLK))

   );While
   (grtext)
   (prin1)
); end blkscl.lsp
